C ********************************************************************
C * BANDPLOT - Plotting and interpolation of energy bands            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  BPENER                                                          *
C *                                                                  *
C *  Routine of BANDPLOT                                             *
C *                                                                  *
C *  Usage......: Input of energy range.                             *
C *                                                                  *
C *  Author.....: Martin Braendle (mbs) c/o                          *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Institute for anorg. + phys. Chemistry             *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: 03.03.92                                           *
C *  Revision...: 01.07.97/mbs                                       *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: BANDPL,BPGRPH                                      *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE BPENER(EMIN,EMAX)
C
C NAG/GKS version.
C
C      DOUBLE PRECISION EMIN,EMAX
C
C PGPLOT version.
C
      REAL EMIN,EMAX

10    WRITE(6,'(/,'' Minimum energy in eV: '',$)')
      READ(5,'(F10.5)',ERR=10) EMIN
20    WRITE(6,'('' Maximum energy in eV: '',$)')
      READ(5,'(F10.5)',ERR=20) EMAX
      IF (EMAX .LE. EMIN) THEN
        WRITE(6,'(/,'' Error: Maximum energy is lower than minimum.'')')
        GOTO 10
      ENDIF
      RETURN
      END