C ********************************************************************
C * CEDiT - Crystal Electronic Dipole-induced Transitions            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  SUBROUTINE GETSEL                                               *
C *                                                                  *
C *  Routine of EDiT/CEDiT                                           *
C *  version for IBM-PC MS-DOS, Microsoft FORTRAN and                *
C *              IBM-RISC UNIX, AIX XL FORTRAN                       *
C *                                                                  *
C *  Usage......: Reads nEDiT input from standard input.             *       
C *                                                                  *
C *  Authors....: Ruedi Rytz                                         *
C *                                                                  *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Institute for anorg. + phys. Chemistry             *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: October 1995                                       *
C *  Revision...:                                                    *
C *                                                                  *
C *  Called from: NEDIT                                              *
C *                                                                  *
C *  Calls......: MATRIX, READL, WRITEL                              *
C *                                                                  *
C ********************************************************************

       SUBROUTINE GETSEL

       IMPLICIT NONE

       INCLUDE 'sizes'

C VAR
       COMMON /IOUNIT/IIN, IOUT, ISTART(40)
       INTEGER IIN, IOUT, ISTART

       CHARACTER*(4*RECLEN) KEYWRD, STRING, TRUNCLS, LCASE
       CHARACTER*(RECLEN) SLINE

       CHARACTER*3 POLARR
       CHARACTER*16 GENFIL, MOFIL, MATRIC

       CHARACTER*1 SPACE
       PARAMETER (SPACE = ' ')

       CHARACTER*(RECLEN) TITLE

       INTEGER I, IP2, STRLEN, I1, IONE 
       INTEGER NPSII, RPSII, NPSIF, RPSIF, NEIGH(3), KSTART, KEND 

C       PARAMETER(IONE=ICHAR('1'))

       DOUBLE PRECISION READA, TOL, DIM(3,3)
       DATA DIM/9*0.0D0/
       DATA NEIGH/3*0.0D0/

C BEGIN

       IONE=ICHAR('1')

C First parameter card TITLE

       TITLE=' '

       CALL READL(SLINE)
       IF (INDEX(SLINE,'TITLE') .NE. 0) THEN
          TITLE = SLINE
          TITLE(1:5) = '     '
          CALL READL(SLINE) 
       ENDIF

C Second parameter card KEYWRD

      KEYWRD=' '
      IP2=1
10    IF (INDEX(SLINE,'KEYWRD') .EQ. 0) GOTO 40
      DO 20 I=80,ISTART(2),-1
        IF (SLINE(I:I) .NE. SPACE) GOTO 30
20    CONTINUE
30    KEYWRD=KEYWRD(1:IP2)//SLINE(ISTART(2):I)//' '
      IP2=IP2+I+2-ISTART(2)
      IF (IP2 .GE. (4*RECLEN)) THEN
        CALL WRITEL(' Too many keywords.',.TRUE.)
      ENDIF
      CALL READL(SLINE)
      GOTO 10
40    CONTINUE

      WRITE(IOUT,50) TITLE
50    FORMAT(/,' ',A,///)

      WRITE(IOUT, '(A,/)' ) ' The following options have been selected:'

      IF (INDEX(KEYWRD,'MOFILE') .NE. 0) THEN
        STRING = KEYWRD( INDEX(KEYWRD,'MOFILE=')+7:4*RECLEN)
        STRING = TRUNCLS(STRING)
        STRING = LCASE(STRING,STRLEN(STRING,' '))
        IF (STRING(1:1) .EQ. '*') THEN
          MOFIL  = (STRING(1:STRLEN(STRING,' '))//'.kpe')
        ELSE
          MOFIL  = (STRING(1:STRLEN(STRING,' '))//'.mo')
        ENDIF
        CALL WRTKEY('MOFILE',MOFIL)
      ELSE
        IF (INDEX(KEYWRD,'CRYST') .EQ. 0) THEN
          CALL WRITEL(' No *.mo file specified.',.TRUE.)
        ENDIF
      ENDIF

      IF (INDEX(KEYWRD,'GENFILE') .NE. 0 ) THEN
        STRING = KEYWRD( INDEX( KEYWRD,'GENFILE=')+8:4*RECLEN )
        STRING = TRUNCLS(STRING)
        STRING = LCASE(STRING,STRLEN(STRING,' '))
        GENFIL = (STRING(1:STRLEN(STRING,' '))//'.gen')
        CALL WRTKEY('GENFILE',GENFIL)
      ELSE
        CALL WRITEL(' No *.gen file specified.',.TRUE.)
      ENDIF 

      IF (INDEX(KEYWRD,'SPECOUT') .GT. 0) THEN
        CALL WRTKEY('SPECOUT',MOFIL)
      ENDIF

      IF (INDEX(KEYWRD,'POL') .NE. 0) THEN
        STRING = KEYWRD( INDEX(KEYWRD,'POL=')+4:4*RECLEN )
        STRING = TRUNCLS(STRING)
        POLARR = STRING(1:STRLEN(STRING,' '))
        DO 55 I = 1, (STRLEN(STRING,' ')-1)
          IF ( .NOT. (POLARR(I:I) .EQ. 'X' .OR.
     .                POLARR(I:I) .EQ. 'Y' .OR.
     .                POLARR(I:I) .EQ. 'Z' ) ) THEN
            CALL WRITEL(' Wrong polarization specified.',.TRUE.)
          ENDIF
55      CONTINUE
        CALL WRTKEY('POL',POLARR)
      ELSE
        CALL WRITEL(' No polarization specified.',.TRUE.)
      ENDIF

      IF (INDEX(KEYWRD,'MATRICE') .NE. 0) THEN
        STRING = KEYWRD( INDEX(KEYWRD,'MATRICE=')+8:4*RECLEN)
        MATRIC = TRUNCLS(STRING)
        IF (INDEX(MATRIC,'ALL')  .EQ. 0 .AND.
     .      INDEX(MATRIC,'BDIAG') .EQ. 0) THEN
          CALL WRITEL(' Wrong Argument for Keyword MATRICE',.TRUE.) 
        ENDIF
        CALL WRTKEY('MATRICE',MATRIC)
      ELSE
        CALL WRITEL(' MATRICE not specified; ALL assumed.',.FALSE.)
        MATRIC = 'ALL'
      ENDIF

      IF ( INDEX(KEYWRD,'CORRECT') .GT. 0 .AND.
     .     INDEX(KEYWRD,'TOLERANCE=') .EQ. 0) THEN
        CALL WRITEL(' Standard TOLERANCE = 1.0D-5 eV assumed.',.FALSE.)
        TOL=1.0D-5
      ENDIF

      IF ( INDEX(KEYWRD,'TOLERANCE=') .GT. 0 .AND.
     .     INDEX(KEYWRD,'CORRECT') .EQ. 0) THEN
        CALL WRITEL(' KEYWRD CORRECT is missing and will be assumed.',
     .               .FALSE.)
        CALL ADDK(KEYWRD,'CORRECT')
      ENDIF

      IF ( INDEX(KEYWRD,'TOLERANCE') .NE. 0) THEN
        STRING = KEYWRD( INDEX(KEYWRD,'TOLERANCE=')+9:4*RECLEN)
        STRING = STRING( INDEX(STRING,'='):4*RECLEN)
        TOL = READA(STRING,1,80)
      ENDIF

      IF (INDEX(KEYWRD,'CORRECT') .GT. 0) THEN           
        WRITE(STRING, '(F6.5)') TOL
        STRING=STRING//' eV'
        CALL WRTKEY('CORRECT',STRING)
      ENDIF

      IF (INDEX(KEYWRD,'TRANSOUT') .GT. 0) THEN
        CALL WRTKEY('TRANSOUT',' ')
      ENDIF

      IF (INDEX(KEYWRD,'MATOUT') .GT. 0) THEN
        CALL WRTKEY('MATOUT',' ')
      ENDIF

      IF (INDEX(KEYWRD,'CRYST') .GT. 0) THEN
        CALL WRTKEY('CRYST',' ')
      ENDIF       

      NPSII=0
      NPSIF=0
      RPSII=0
      RPSIF=0
      KSTART=0
      KEND=0

C Now we get all other cards until the end of the input is reached. 

C Initialize numbers of the wave functions
C First CARD [WAVENUMBER]

60    CONTINUE
      IF ( INDEX(SLINE,'STOP') .EQ. 0) THEN

          IF ( (INDEX(SLINE,'[') .NE. 0) .AND. 
     .         (INDEX(SLINE,']') .NE. 0) )  THEN

            IF (INDEX(SLINE,'WAVERANGE') .NE. 0) THEN
              CALL ADDK(KEYWRD,'WAVERANGE')

              DO 70 I = 1, 2 

                CALL READL(SLINE)
                IF (INDEX(SLINE,'START') .NE. 0) THEN
                  IF (ISTART(2) .NE. RECLEN+1) THEN
                    NPSII = INT(READA(SLINE,ISTART(2),80))
                  ELSE
                    CALL WRITEL(' Bad or missing START wave function.',
     .                            .TRUE.)
                  ENDIF
                  RPSII = INT(READA(SLINE,ISTART(3),80))
                  IF (RPSII .LT. NPSII) RPSII=NPSII
                ELSEIF (INDEX(SLINE,'END') .NE. 0) THEN
                  IF (ISTART(2) .NE. RECLEN+1) THEN
                    NPSIF = INT(READA(SLINE,ISTART(2),80))
                  ELSE
                    CALL WRITEL(' Bad or missing END wave function.',
     .                            .TRUE.)
                  ENDIF
                  RPSIF = INT(READA(SLINE,ISTART(3),80))
                  IF (RPSIF .LT. NPSIF) RPSIF=NPSIF
                ENDIF 
70            CONTINUE
            ENDIF ! IF (INDEX(SLINE,'WAVERANGE') .NE. 0) THEN

C CARD [CELL]

            IF (INDEX(SLINE,'CELL') .NE. 0) THEN
   
90            CONTINUE
              CALL READL(SLINE)
              I1 = ICHAR(SLINE(1:1)) - IONE 
              IF ( (I1 .GE. 0) .AND. (I1 .LE. 2) ) THEN
                IF (I1 .EQ. 0) THEN
                  DIM(1,1) = READA(SLINE,ISTART(3),80)
                  DIM(1,2) = READA(SLINE,ISTART(4),80)
                  DIM(1,3) = READA(SLINE,ISTART(5),80)
                  NEIGH(1) = INT(READA(SLINE,ISTART(7),80))
                ELSE IF (I1 .EQ. 1) THEN
                  DIM(2,1) = READA(SLINE,ISTART(3),80)
                  DIM(2,2) = READA(SLINE,ISTART(4),80)
                  DIM(2,3) = READA(SLINE,ISTART(5),80)
                  NEIGH(2) = INT(READA(SLINE,ISTART(7),80))
                ELSE IF (I1 .EQ. 2) THEN
                  DIM(3,1) = READA(SLINE,ISTART(3),80)
                  DIM(3,2) = READA(SLINE,ISTART(4),80)
                  DIM(3,3) = READA(SLINE,ISTART(5),80)
                  NEIGH(3) = INT(READA(SLINE,ISTART(7),80))
                ENDIF
                GOTO 90
              ENDIF

            ENDIF ! IF (INDEX(SLINE,'CELL') .NE. 0)  THEN

C CARD [KPOINTS]

            IF(INDEX(SLINE,'KPOINTS') .NE. 0) THEN

              DO 100 I = 1, 2 
                CALL READL(SLINE)
                IF (INDEX(SLINE,'START') .NE. 0) THEN
                  IF (ISTART(2) .NE. RECLEN+1) THEN
                    KSTART = INT(READA(SLINE,ISTART(2),80))
                  ELSE
                    CALL WRITEL(' Bad or missing START k-point.',
     .                            .TRUE.)
                  ENDIF
                ELSEIF (INDEX(SLINE,'END') .NE. 0) THEN
                  IF (ISTART(2) .NE. RECLEN+1) THEN
                    KEND = INT(READA(SLINE,ISTART(2),80))
                  ELSE
                    CALL WRITEL(' Bad or missing END k-point.',
     .                            .TRUE.)
                  ENDIF
                ENDIF 
100           CONTINUE

            ENDIF ! IF (INDEX(SLINE,'KPOINTS') .NE. 0)  THEN

          ENDIF  

        CALL READL(SLINE)
        GOTO 60
      ENDIF ! IF (SLINE .NE. 'STOP') THEN

      CALL READWA(GENFIL, MOFIL, MATRIC, POLARR, NPSII, RPSII, 
     .            NPSIF, RPSIF, TOL, KEYWRD, DIM, NEIGH, KSTART, KEND)

      RETURN
      END
C END
