C ********************************************************************
C * CEDiT - Crystal Electronic Dipole-induced Transitions            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  SUBROUTINE OUT                                                  *
C *                                                                  *
C *  Routine of EDiT/CEDiT                                           *
C *  version for IBM-PC MS-DOS, Microsoft FORTRAN and                *
C *              IBM-RISC UNIX, AIX XL FORTRAN                       *
C *                                                                  *
C *  Usage......: Prints out the results of the calculation.         *
C *                                                                  *
C *  Authors....: Ruedi Rytz                                         *
C *                                                                  *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Institute for anorg. + phys. Chemistry             *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: June 1992                                          *
C *  Revision...: June 1993/rr                                       *
C *                                                                  *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: MATRIX                                             *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE OUT(SUM, POL, DEGEN, EPSII, EPSIF)

      IMPLICIT NONE

      INCLUDE 'edconst.inc'

        DOUBLE PRECISION   SUM
        CHARACTER*1        POL
        INTEGER            DEGEN
        DOUBLE PRECISION   EPSII, EPSIF

C VAR
      COMMON /IOUNIT/IIN,IOUT,ISTART(40)
      INTEGER IIN, IOUT, ISTART

      DOUBLE PRECISION  DELTAE

C BEGIN
      WRITE(IOUT, ' (A, A1, A, 1X, F11.5  ) ' )
     .                          ' Oscillator strength along ',POL,':', 
     .                            FAC * SUM**2 * DELTAE (EPSII, EPSIF) *
     .                            CM / DEGEN

      RETURN
      END
C END
