C ********************************************************************
C * EHMACC - Extended Hueckel Molecular and Crystal Calculations     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  AOOUT                                                           *
C *                                                                  *
C *  Routine of EHMACC                                               *
C *                                                                  *
C *  Usage......: Reads cards # 10 AOOUT.                            *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987, 01.05.92 (Martin Braendle (mbs), c/o    *
C *               Calzaferri group, Inst. f. Inorg. and Phys. Chem., *
C *               Freiestr. 3, CH-3012 Berne)                        *
C *  Remarks....: Slight modifications of COMMON blocks.             *
C *                                                                  *
C *  Called from: PART1                                              *
C *                                                                  *
C *  Calls......: ADDK,SEARCH,READL                                  *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE AOOUT
 
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
 
      INCLUDE 'sizes'

      CHARACTER    TEX1*11,TEX2*11,MOT*12 
      CHARACTER*7  ELEM(NSYMMX)
      CHARACTER*20 TEXTF(20)
 
      COMMON /KEYWRD/KEYWRD,SLINE
      CHARACTER KEYWRD*320,SLINE*80
 
      COMMON /IOUNIT/IIN,IOUT,ISTART(40)
      COMMON /DELET/IND(NDIMMX),INDIM,IVAL,NORBE(NATMMX),NDEL
      COMMON /OPTV/RHO,FERMI,WSTART,WEND,DISTL,LB,LE,LBR,LER,IOVLB,
     .             IOVLE,ICHARG,NELEC,IDISTN,IEB,IEE,ISB,ISE,IHB,IHE,
     .             IPOPE,JPOPE,IREST,IRESTV
      COMMON /AOOUT1/INDTS(NDIMMX)
      COMMON /TEMP1/NORBEF(NATMMX)
 
C
C options
C
      LDIM=INDIM-NDEL
      DO 10 I=1,LDIM
        INDTS(I)=1
   10 CONTINUE
 
      ICARD=0
      IF (INDEX(SLINE,'AOOUT') .EQ. 0) GOTO 60
      MOT='AOOUT'
      CALL ADDK (MOT)
      ICARD=1
 
      WRITE (IOUT,20)
   20 FORMAT(' ')
      DO 30 I=1,LDIM
        INDTS(I)=0
   30 CONTINUE
 
   40 IF (INDEX(SLINE,'AOOUT') .EQ. 0) GOTO 60
      CALL SEARCH(TEXTF,NN,ELEM,KK,NORBEF,IND,NORBE,INDTS)
      CALL READL
      TEXTF(1)=' AOOUT '
      TEX1=' orbital : '
      TEX2=' element : '
      WRITE(IOUT,50) TEXTF(1),TEX2,(ELEM(L),L=1,KK),TEX1,
     .               (TEXTF(L),L=2,NN)
   50 FORMAT(1X,131A)
      GOTO 40
 
   60 NNN=0
      IF (LBR .EQ. 0) LBR=1
      IF (LER .EQ. 0) LER=LDIM
      DO 70 I=1,LDIM
        IF ((I .LT. LBR) .OR. (I .GT. LER)) INDTS(I)=0
        IF (INDTS(I) .NE. 0) NNN=NNN+1
   70 CONTINUE
      IF (ICARD .EQ. 1) WRITE(IOUT,80) NNN
   80 FORMAT(2X,' AOOUT : ',I3,' orbitals')
 
      RETURN
      END
