C ********************************************************************
C * EHMACC - Extended Hueckel Molecular and Crystal Calculations     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  MATMUL                                                          *
C *                                                                  *
C *  Usage......: Matrixmultiplication of two matrices A and B.      *
C *                                                                  *
C *  Author.....: Martin Braendle (mbs)                              *
C *  Date.......: 11.09.92                                           *
C *  Revision...: -                                                  *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: GETSYM                                             *
C *                                                                  *
C ********************************************************************

      SUBROUTINE MATMUL(A,B,C,NA1,NA2,NB1,NB2)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION A(NA1,NA2),B(NB1,NB2),C(NA1,NB2)

      IF (NA2 .NE. NB1) RETURN

      DO 30 I=1,NA1
        DO 20 J=1,NB2
          TEMP=0.0D0
          DO 10 K=1,NA2
            TEMP=TEMP+A(I,K)*B(K,J)
10        CONTINUE
          C(I,J)=TEMP
20      CONTINUE       
30    CONTINUE
      
      RETURN
      END
