C ********************************************************************
C * EHMACC - Extended Hueckel Molecular and Crystal Calculations     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  MOPOP1                                                          *
C *                                                                  *
C *  Routine of EHMACC                                               *
C *                                                                  *
C *  Usage......: Output of overlap populations.                     *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987, 05.05.92/mbs (Martin Braendle c/o       *
C *               Calzaferri group, Inst. f. Inorg. and Phys. Chem., *
C *               Freiestr. 3, CH-3012 Berne)                        *
C *  Remarks....: Slight modification of COMMON blocks.              *
C *                                                                  *
C *  Called from: BPOP                                               *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
      SUBROUTINE MOPOP1 (X,NN,LBR,LER,LB,LE,M1,M2)

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      INCLUDE 'sizes'

      DIMENSION X(NN,NN)

      COMMON /IOUNIT/ IIN,IOUT,ISTART(40)
      COMMON /ATOM1/NS(NSYMMX,NAEQMX),NP(NSYMMX),ND(NSYMMX),NF(NSYMMX),
     .              INATOM,ISYM(NATMMX),NELEM

      COMMON /ATO/AC(NATMMX),SYMBOL(NSYMMX)
      CHARACTER AC*7,SYMBOL*2

      IFLAG=1
      ILOWER=LB
      NL=LE

   10 IUPPER=ILOWER+12
      IF (IUPPER-NL) 30,20,20
   20 IUPPER=NL
      IFLAG=0
   30 WRITE(IOUT,40) (J-M2+1,J=ILOWER,IUPPER)
   40 FORMAT(/,9X,13I8)
      WRITE(IOUT,50)
   50 FORMAT(' ')

      IL1=ILOWER
      IU1=IUPPER

      DO 60 I=LBR,LER
        II=I-M1+1
   60 WRITE(IOUT,70) AC(II),(X(I,J),J=IL1,IU1)
   70 FORMAT(2X,A7,2X,13F8.4)
      WRITE(IOUT,50)

      IF (IFLAG) 80,90,80
   80 ILOWER=ILOWER+13
      GOTO 10

   90 RETURN
      END
