C ********************************************************************
C * EHMACC - Extended Hueckel Molecular and Crystal Calculations     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  OMATT                                                           *
C *                                                                  *
C *  Routine of EHMACC                                               *
C *                                                                  *
C *  Usage......: Output of overlap populations.                     *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987, 06.05.92/mbs (Martin Braendle, c/o      *
C *               Calzaferri group, Inst. f. Inorg. and Phys. Chem., *
C *               Freiestr. 3, CH-3012 Berne)                        *
C *  Remarks....: Slight modification of COMMON blocks.              *
C *                                                                  *
C *  Called from: BPOP                                               *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE OMATT(X,NN,LBR,LER,LB,LE,IMAT,MM)

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      INCLUDE 'sizes'

      DIMENSION X(NN,NN),IMAT(NDIMMX)
      CHARACTER TEXT*10

      COMMON /IOUNIT/IIN,IOUT,ISTART(40)
      COMMON /DELET/IND(NDIMMX),INDIM,IVAL,NORBE(NATMMX),NDEL
      COMMON /ATOM1/NS(NSYMMX,NAEQMX),NP(NSYMMX),ND(NSYMMX),NF(NSYMMX),
     .              INATOM,ISYM(NATMMX),NELEM
      COMMON /AOOUT1/INDTS(NDIMMX)

      COMMON /ATO/AC(NATMMX),SYMBOL(NSYMMX)
      CHARACTER AC*7,SYMBOL*2

      COMMON /AOOUT2/INDT(NDIMMX,2)
      CHARACTER INDT*10

      IFLAG=1
      ILOWER=LB
      NL=LE

   10 IUPPER=ILOWER+11
      IF (IUPPER-NL) 30,20,20
   20 IUPPER=NL
      IFLAG=0
   30 WRITE(IOUT,40) (J,J=ILOWER-MM+1,IUPPER-MM+1)
   40 FORMAT(27X,12I8)

      IL1=ILOWER
      IU1=IUPPER
      TEXT=' '
      DO 80 I=LBR,LER
        IF (IMAT(I) .EQ. 0) GOTO 80
        II=I-MM+1
        IF (INDT(I,1) .EQ. TEXT) THEN
          WRITE(IOUT,50) INDT(I,2),II,(X(I,J),J=IL1,IU1)
   50     FORMAT(12X,A10,2X,I3,2X,12F8.4)
        ELSE
          WRITE(IOUT,60)
   60     FORMAT(' ')
          WRITE(IOUT,70) (INDT(I,L),L=1,2),II,(X(I,J),J=IL1,IU1)
   70     FORMAT(2X,2A10,2X,I3,2X,12F8.4)
        ENDIF
        TEXT=INDT(I,1)
   80 CONTINUE
      WRITE(IOUT,60)

      IF (IFLAG) 90,100,90
   90 ILOWER=ILOWER+12
      GOTO 10

  100 RETURN
      END
