C ********************************************************************
C * EHPC - Extended Hueckel properties calculations                  *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  GETORB                                                          *
C *                                                                  *
C *  Routine of EHPC                                                 *
C *                                                                  *
C *  Usage......: Processes orbital name information.                *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987                                          *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: SEARCH                                             *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE GETORB(ITD,ISD,IPD,IDD,IFD,IPX,IDX,IFX,NN,TEXT)

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      DIMENSION IPX(3),IDX(5),IFX(7)
      CHARACTER*10 TEXT(20)

      COMMON /IOUNIT/ IIN,IOUT,ISTART(40)

      COMMON /KEYWRD/ KEYWRD,SLINE
      CHARACTER KEYWRD*320,SLINE*80

      ITD=INDEX(SLINE,'T.')
      ISD=INDEX(SLINE,'S.')
      IPD=INDEX(SLINE,'P.')
      IPX(1)=INDEX(SLINE,'PX')
      IPX(2)=INDEX(SLINE,'PY')
      IPX(3)=INDEX(SLINE,'PZ')
      IDD=INDEX(SLINE,'D.')
      IDX(1)=INDEX(SLINE,'DX2-Y2')
      IDX(2)=INDEX(SLINE,'DZ2')
      IDX(3)=INDEX(SLINE,'DXY')
      IDX(4)=INDEX(SLINE,'DXZ')
      IDX(5)=INDEX(SLINE,'DYZ')
      IFD=INDEX(SLINE,'F.')
      IFX(1)=INDEX(SLINE,'FZ3')
      IFX(2)=INDEX(SLINE,'FXZ2')
      IFX(3)=INDEX(SLINE,'FYZ2')
      IFX(4)=INDEX(SLINE,'FXYZ')
      IFX(5)=INDEX(SLINE,'FZ(X2-Y2)')
      IFX(6)=INDEX(SLINE,'FX(X2-3Y2)')
      IFX(7)=INDEX(SLINE,'FY(3X2-Y2)')
      NN=1
      IF (ITD .NE. 0) THEN
        NN=NN+1
        TEXT(NN)='t'
      ENDIF
      IF (ISD .NE. 0) THEN
        NN=NN+1
        TEXT(NN)='s'
      ENDIF
      IF (IPD .NE. 0) THEN
        NN=NN+1
        TEXT(NN)='p'
      ENDIF
      IF (IPX(1) .NE. 0) THEN
        NN=NN+1
        TEXT(NN)='px'
      ENDIF
      IF (IPX(2) .NE. 0) THEN
        NN=NN+1
        TEXT(NN)='py'
      ENDIF
      IF (IPX(3) .NE. 0) THEN
        NN=NN+1
        TEXT(NN)='pz'
      ENDIF
      IF (IDD .NE. 0) THEN
        NN=NN+1
        TEXT(NN)='d'
      ENDIF
      IF (IDX(1) .NE. 0) THEN
        NN=NN+1
        TEXT(NN)='dx2-y2'
      ENDIF
      IF (IDX(2) .NE. 0) THEN
        NN=NN+1
        TEXT(NN)='dz2'
      ENDIF
      IF (IDX(3) .NE. 0) THEN
        NN=NN+1
        TEXT(NN)='dxy'
      ENDIF
      IF (IDX(4) .NE. 0) THEN
        NN=NN+1
        TEXT(NN)='dxz'
      ENDIF
      IF (IDX(5) .NE. 0) THEN
        NN=NN+1
        TEXT(NN)='dyz'
      ENDIF
      IF (IFD .NE. 0) THEN
        NN=NN+1
        TEXT(NN)='f'
      ENDIF
      IF (IFX(1) .NE. 0) THEN
        NN=NN+1
        TEXT(NN)='fz3'
      ENDIF
      IF (IFX(2) .NE. 0) THEN
        NN=NN+1
        TEXT(NN)='fxz2'
      ENDIF
      IF (IFX(3) .NE. 0) THEN
        NN=NN+1
        TEXT(NN)='fyz2'
      ENDIF
      IF (IFX(4) .NE. 0) THEN
        NN=NN+1
        TEXT(NN)='fxyz'
      ENDIF
      IF (IFX(5) .NE. 0) THEN
        NN=NN+1
        TEXT(NN)='fz(x2-y2)'
      ENDIF
      IF (IFX(6) .NE. 0) THEN
        NN=NN+1
        TEXT(NN)='fx(x2-3y2)'
      ENDIF
      IF (IFX(7) .NE. 0) THEN
        NN=NN+1
        TEXT(NN)='fy(3x2-y2)'
      ENDIF
      NN=NN+1
      RETURN
      END
