C ********************************************************************
C * EHPC - Extended Hueckel properties calculations                  *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  OUTPUT                                                          *
C *                                                                  *
C *  Routine of EHPC                                                 *
C *                                                                  *
C *  Usage......: Ordered output of a vector.                        *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987                                          *
C *  Remarks....:                                                    *
C *                                                                  *
C *  Called from: SMOOTH,SMOOTO,SMOOTB                               *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE OUTPUT(A,N)

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      DIMENSION A(N)

      COMMON /IOUNIT/IIN,IOUT,ISTART(40)

      NRUN=N/10
      IF (NRUN*10 .LT. N) NRUN=NRUN+1
      M=0

      DO 20 I=1,NRUN
        M=M+1
        J1=(M-1)*10+1
        J2=M*10
        IF (J2 .GT. N) J2=N
        WRITE (IOUT,10) M,(A(J),J=J1,J2)
   10   FORMAT(1X,I4,2X,10F11.4)
   20 CONTINUE

      RETURN
      END
