C ********************************************************************
C * EHPC - Extended Hueckel properties calculations                  *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  SEARCH                                                          *
C *                                                                  *
C *  Routine of EHPC                                                 *
C *                                                                  *
C *  Usage......: Classifies and assembles the set of atoms and that *
C *               of atomic orbitals for various calculations.       *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987, 12.06.92/mbs (Martin Braendle, c/o      *
C *               Calzaferri group, Inst. f. Inorg. and Phys. Chem., *
C *               Freiestr. 3, CH-3012 Berne)                        *
C *  Remarks....: Slight modification of COMMON blocks.              *
C *                                                                  *
C *  Called from: GPROJ                                              *
C *                                                                  *
C *  Calls......: GETORB,GETNAM                                      *
C *                                                                  *
C ********************************************************************

      SUBROUTINE SEARCH(TEXT,NN,ELEM,KK,IORBF,INDF,IORB,IXX)

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      INCLUDE 'sizes'

      DIMENSION IORBF(NATMMX),INDF(NDIMMX),IORB(NATMMX),IXX(NDIMMX),
     .          IPX(3),IDX(5),IFX(7)
      CHARACTER*7  ELEM(40),AC1,ELEMT
      CHARACTER*10 TEXT(20)
      CHARACTER*80 STRING

      COMMON /ATO/AC(NATMMX),SYMBOL(NSYMMX)
      CHARACTER AC*7,SYMBOL*2

      COMMON /ATOM1/NSS(NSYMMX),NPP(NSYMMX),NDD(NSYMMX),NFF(NSYMMX),
     .              IATOM,ISYM(NATMMX),NELEM

      CALL GETORB(ITD,ISD,IPD,IDD,IFD,IPX,IDX,IFX,NN,TEXT)
      KK=0
      NNP1=NN+1
      DO 100 I=NNP1,40
C
C get the name
C
        IT=0
        CALL GETNAM(I,STRING,IT)
        IF (IT .EQ. 1) GOTO 100
        ELEMT=STRING(1:7)
        KK=KK+1
        ELEM(KK)=ELEMT
        IDORB=1
        IJK=0
        DO 90 J=1,IATOM
          IDORB=IDORB+IORBF(J)
          IJK=IJK+IORB(J)
          AC1=AC(J)
          IF (STRING(1:2) .EQ. 'XX') ELEMT=AC(J)
          IF (STRING(4:5) .EQ. 'XX') ELEMT(4:5)=AC1(4:5)
          DO 10 K=1,7
            IF (K .GT. 2) THEN
              IF (ELEMT(K:K) .NE. AC1(K:K) .AND. ELEMT(K:K) .NE. ' ') 
     .        GOTO 90
            ELSE
              IF (ELEMT(K:K) .NE. AC1(K:K)) GOTO 90
            ENDIF
   10     CONTINUE
          IDORB=IDORB-IORBF(J)
          IJK=IJK-IORB(J)
          DO 20 K=1,NELEM
            IF (SYMBOL(K) .NE. ELEMT(1:2)) GOTO 20
            NUMB=K
   20     CONTINUE

          IF (NSS(NUMB) .EQ. 0) GOTO 30
          IF (INDF(IDORB) .EQ. 0) THEN
            IJK=IJK+1
            IF (ITD .NE. 0) IXX(IJK)=1
            IF (ISD .NE. 0) IXX(IJK)=1
          ENDIF
          IDORB=IDORB+1
   30     IF (NPP(NUMB) .EQ. 0) GOTO 50
          DO 40 IK=1,3
            IF (INDF(IDORB) .EQ. 0) THEN
              IJK=IJK+1
              IF (ITD .NE. 0) IXX(IJK)=1
              IF (IPD .NE. 0) IXX(IJK)=1
              IF (IPX(IK) .NE. 0) IXX(IJK)=1
            ENDIF
            IDORB=IDORB+1
   40     CONTINUE
   50     IF (NDD(NUMB) .EQ. 0) GOTO 70
          DO 60 IK=1,5
            IF (INDF(IDORB) .EQ. 0) THEN
              IJK=IJK+1
              IF (ITD .NE. 0) IXX(IJK)=1
              IF (IDD .NE. 0) IXX(IJK)=1
              IF (IDX(IK) .NE. 0) IXX(IJK)=1
            ENDIF
            IDORB=IDORB+1
   60     CONTINUE
   70     IF (NFF(NUMB) .EQ. 0) GOTO 90
          DO 80 IK=1,7
            IF (INDF(IDORB) .EQ. 0) THEN
              IJK=IJK+1
              IF (ITD .NE. 0) IXX(IJK)=1
              IF (IFD .NE. 0) IXX(IJK)=1
              IF (IFX(IK) .NE. 0) IXX(IJK)=1
            ENDIF
            IDORB=IDORB+1
   80     CONTINUE
   90   CONTINUE
  100 CONTINUE

      NN=NN-1
      RETURN
      END
