C ********************************************************************
C * KMESHPEG - Program Package in Order to Compute k-sets            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  OBLIQ1                                                          *
C *                                                                  *
C *  Usage......: Generates k-point mesh of oblique lattice, grid    *
C *               type 1, according to R. Ramirez, M.C. Boehm, Int.  *
C *               J. Quant. Chem. 30 (1986) 391                      *
C *                                                                  *
C *  Author.....: M. Braendle (mbs)                                  *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Institute for anorg. + phys. Chemistry             *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *  Date.......: 26.10.94                                           *
C *  Revision...: /mbs (Martin Braendle)                             *
C *  Remarks....: -                                                  *
C *                                                                  *
C ********************************************************************

      PROGRAM OBLIQ1

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      CHARACTER*80 STRING

      WRITE(6,10)
10    FORMAT(/,' Generate k-point mesh (oblique lattice)',/)
20    WRITE(6,30)
30    FORMAT(' Number of k-points along x direction, total is ',
     .       '2*(N-1)^2+2: ',$)
      READ(5,40,ERR=20) N
40    FORMAT(I3)
      IF (N .LT. 2) GOTO 20

      WRITE(6,50) 
50    FORMAT(' Enter optional string for output options: ',$)
      READ(5,60) STRING
60    FORMAT(A80)
      
      WRITE(1,70) 2*(N-1)*(N-1)+2
70    FORMAT('!',/,'! Oblique lattice, grid type 1, according to ',/,
     .       '! R. Ramirez, M.C. Boehm, Int. J. Quant. Chem. 30 (1986)',
     .       ' 391',/,'! ',I3,' k points',/,'!')

      X=0.0D0
      XSTEP=0.5D0/DBLE(N-1)
      YSTEP=XSTEP 
      DO 110 I=1,N
        Y=0.5D0
        M=2*(N-1)
        IF ((I .EQ. 1) .OR. (I .EQ. N)) M=N
        DO 100 J=1,M
          NWEIGT=2
          IF (((I .EQ. 1) .AND. ((J .EQ. 1) .OR. (J .EQ. N))) .OR.
     .        ((I .EQ. N) .AND. ((J. EQ. 1) .OR. (J .EQ. N)))) THEN
            NWEIGT=1
          ENDIF 
          WRITE(1,80) X,Y,0.0D0,NWEIGT
80        FORMAT('KPIN ',3(F13.10,1X),I1)
          IF (STRING(1:1) .GT. ' ') THEN
            WRITE(1,90) STRING
90          FORMAT(A80)
          ENDIF
          Y=Y-YSTEP
100     CONTINUE
        X=X+XSTEP
110   CONTINUE
      STOP
      END
